/*
 * Utility class to do some basic conversions
 * Avrum Tilman
 * amt77@columbia.edu
 * avrum@cs.columbia.edu
 */


public class MyUtil
{
	public static byte[] subArray(byte[] input, int start, int length)
	{
		byte[] out = new byte[length];

		for(int l=0;l<length;l++)
			out[l]=input[start+l];
		return out;
	}

	public static byte[] convert(int val)
        //get a byte array for the given integer 
	{
		byte[] out = new byte[256];
		byte[] ret;
		Integer parse;
		int mod, l=0;

		while(val>0)
		{
			mod=val%256;
			val=val/256;
			parse = new Integer(unsigned(mod));

			out[l]=parse.byteValue();
			l++;
		}

		ret = new byte[l];
		for(int i=0;i<l;i++)
		{
			ret[i]=out[l-i-1];
		}
		return ret;
	}

	public static int convert(byte[] val)
	//convert the given byte array back into an integer
	{
		int ret;

		ret=unsigned(val[0]);
		for(int l=1;l<val.length;l++)
		{
			ret=ret*256+unsigned(val[l]);
		}
		return ret;
	}

	public static int unsigned(int x)
	//keep the bit value correct for unsigned number
	{
		if (x>127)
		{
			return (x-256);
		}
		return x;
	}

	public static int unsigned(byte x)
	//get the real integer value given an unsigned byte
	{
		if(x<0)
		{
			return (x+256);
		}
		return x;

	}
	public static void printBytes(byte[] data)
	//print all the bytes for debugging purposes
	{
		for(int i=0;i<data.length;i++)
			System.out.print(Integer.toBinaryString(data[i]) + " ");
		System.out.println("");
	}
}
